/******************************************************************************
 *  Name:    ________________________
 *  NetID:   ________________________
 *  Precept: ________________________
 *
 *  Description: _____________________________________________________________
 ******************************************************************************/

public class ToyStory {
    
    // a symbol table whose keys are memory locations and whose values are instructions
    private ST<______, ______> code;
    
    // adds each line to the ST, where a line is a String in the format: "XX: XXXX"
    public ToyStory(String[] lines) {
        
    }
    
    // return a String containing the program, in the form: "XX: XXXX\nXX: XXXX\n"
    public String toString() {
        
    }
    
    // returns true if there is an instruction defined at memory location 'mem'
    public boolean isDefined(String mem) {
        
    }
    
    // returns true if instruction at 'mem' has op code C or D and ends in 'addr'
    // special case: returns false if there is no instruction defined at 'mem'
    public boolean containsJumpTo(String mem, String addr) {
        
    }
       
    // FOR FULL CREDIT, MUST CORRECTLY USE containsJumpTo() AND increment() (SEE BELOW)
    // finds all instructions that jump to 'addr' and changes them to jump to 'addr'+1
    public void incrementAllJumpsTo(String addr) {
        
        
    }
    
    // DO NOT EDIT THIS METHOD
    // IT IS PROVIDED TO MAKE INCREMENTING EASIER IN THE METHOD ABOVE
    // takes a 2-hex-digit number as input, gives the next 2-digit-hex number as output
    // for example, increment("19") returns "1A"
    public static String increment(String addr) {
        return String.format("%02X", Integer.parseInt(addr, 16) + 1);
    }
    
    // EXTRA CREDIT
    // FOR ONE POINT, IMPLEMENT A WORKING NON-RECURSIVE SOLUTION
    // FOR TWO POINTS, IMPLEMENT A WORKING RECURSIVE SOLUTION
    // move all consecutive instructions at and after memory address 'min' down
    // to the following memory address. also, maintains connections between all
    // jumps and the instructions they jump to by calling incrementAllJumpsTo()
    public void renumberAfter(String min) {
        
    }
    
    
    // THIS METHOD IS PROVIDED TO HELP YOU TEST YOUR EXTRA CREDIT
    // UNCOMMENT THE CODE BELOW IF YOU WANT TO USE IT
    // associates 'mem' with 'instruction' and updates the existing code accordingly 
    public void addLine(String mem, String instruction) {
        /*
        // before we add this line, let's push everything down
        if (isDefined(mem)) renumberAfter(mem);
        
        // then add this line
        code.put(mem, instruction);
        */
    }
    
    // YOU MAY EDIT THIS METHOD BUT CODE WRITTEN HERE WILL NOT BE GRADED
    public static void main(String[] args) {
        
        // THIS IS JUST A DUMMY TOY PROGRAM TO TEST YOUR CODE
        String[] toy = { "10: 1000", "11: C010" };
        
        // READ IT IN, PRINT IT OUT
        ToyStory story = new ToyStory(toy);
        StdOut.println(story.toString());
        
        // ARE THERE INSTRUCTIONS DEFINED AT THESE MEMORY LOCATIONS?
        StdOut.println(story.isDefined("10")); // TRUE
        StdOut.println(story.isDefined("12")); // FALSE
        
        // DO THE FOLLOWING LINES CONTAIN JUMPS TO THESE ADDRESSES?
        StdOut.println(story.containsJumpTo("11", "10")); // TRUE
        StdOut.println(story.containsJumpTo("11", "11")); // FALSE
        StdOut.println(story.containsJumpTo("12", "10")); // FALSE
                           
        // LET'S CHANGE ALL JUMPS TO 10 TO JUMP TO 11 INSTEAD
        story.incrementAllJumpsTo("10");
        StdOut.println(story);
        // RESULT: "10: 1000\n11: C011\n"
        
        // OPTIONALLY, TEST YOUR EXTRA CREDIT BELOW
    }
}